/* $Id: byteswap.c,v 1.2 1998/03/18 02:58:32 dpwe Exp $

   $Log: byteswap.c,v $
   Revision 1.2  1998/03/18 02:58:32  dpwe
   byteswap support

   Revision 1.1  1997/06/26 23:42:50  dpwe
   Initial revision

   Revision 1.1  1996/10/18 23:15:16  bedk
   Initial revision

   Program to reverse all the bytes in a file, in 2 or 4 word blocks.
   1997jun26 dpwe@icsi.berkeley.edu 
 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "byteswap.h"

/* split command-line arguments of the form arg=val
   into arg and val */ 

int getargval(char* s, char** arg, char** val)
{
  char* eq;

  eq = strchr(s, '=');
  if( eq == NULL) {return 0;}

  *arg = malloc((eq - s + 1) * sizeof(char));
  strncpy(*arg, s, eq - s);
  *(*arg + (eq - s)) = '\000';

  *val = malloc((strlen(s) - (eq - s)));
  strncpy(*val, eq + 1, strlen(s) - (eq - s) - 1);
  *(*val + strlen(s) - (eq - s) - 1) = '\000';
  return 1;
}

int word_size = 2;

int main(int argc, char** argv)
{
  int  nread, t, i = 1;
  FILE *infile = stdin;
  FILE *outfile = stdout;
  char *buf;

  while (i < argc) {
      char *arg, *val;
      if (getargval(argv[i], &arg, &val) == 0) { arg = ""; } /* force err */
      if(strcmp(arg, "size")==0) {
	  word_size = atoi(val);
      } else {
	  fprintf(stderr, "Unrecognized option: '%s'\n", argv[i]);
      }
      ++i;
  }
  if (word_size <= 0) {
      fprintf(stderr, "Usage: %s [width=2] < stdin > stdout\n", argv[0]);
      fprintf(stderr, "  Reverses the byte ordering in each word.\n");
      fprintf(stderr, "  width is the number of bytes per word.\n");
      exit(-1);
  }

#define BLOCK	4096

  buf = malloc(BLOCK*word_size);
  if(!buf) { fprintf(stderr, "unable to alloc buf of %d bytes\n", BLOCK*word_size);
             exit(-1); }
  while (!feof(infile)) {
      if (nread = fread_swap(buf, word_size, BLOCK, infile, 0)) {
	  fwrite_swap(buf, word_size, nread, outfile, 1);
      }
  }
  return 0;
}
